{
    unsigned int gapSeed = worldSeed;
    //Init some blank holes in the map (why not!)
    unsigned int counter = 0;
    //I think it's about 1 in 16 to get a gap?
    for (counter = 16; counter < ((BOOLS_NEEDED_TO_STORE_MAP+7)/8); counter++) {
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        tunneledArray[counter] = gapSeed % 255 & ((gapSeed >> 8) % 255);
    }
    for (counter = 16; counter < ((BOOLS_NEEDED_TO_STORE_MAP+7)/8); counter++) {
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        tunneledArray[counter] &= gapSeed % 255 & ((gapSeed >> 8) % 255);
    }
    for (counter = 16; counter < ((BOOLS_NEEDED_TO_STORE_MAP+7)/8); counter++) {
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        tunneledArray[counter] &= gapSeed % 255 & ((gapSeed >> 8) % 255);
    }
    /*for (counter = 16; counter < ((BOOLS_NEEDED_TO_STORE_MAP+7)/8); counter++) {
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        tunneledArray[counter] &= gapSeed % 255;
    }*/
    
    //more random holes but only next to others to make tunnels.
    counter = 0;
    //for (counter = 0; counter < 50; counter++) {
    for (counter = 0; counter < 7200; counter++) {
        unsigned int rand = (BOOLS_NEEDED_TO_STORE_MAP) + 1;
        while (rand >= (BOOLS_NEEDED_TO_STORE_MAP) || rand < (28/2)*10) {
            gapSeed ^= (gapSeed << 13);
            gapSeed ^= (gapSeed >> 9);
            gapSeed ^= (gapSeed << 7);
            rand = gapSeed;
        }
        if ( (tunneledArray[(rand+1)/8] & 1 << (rand+1)%8) || (tunneledArray[(rand-1)/8] & 1 << (rand-1)%8)
            || (tunneledArray[(rand+(28/2))/8] & 1 << (rand+(28/2))%8) || (tunneledArray[(rand-(28/2))/8] & 1 << (rand-(28/2))%8)) {
            tunneledArray[rand/8] |= 1 << rand%8;
        }
    }
    
    //random speckles
    for (counter = 16; counter < ((BOOLS_NEEDED_TO_STORE_MAP+7)/8); counter++) {
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        unsigned int rand1 = gapSeed;
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        unsigned int rand2 = gapSeed;
        gapSeed ^= (gapSeed << 13);
        gapSeed ^= (gapSeed >> 9);
        gapSeed ^= (gapSeed << 7);
        
        tunneledArray[counter] |= gapSeed % 255 & ((gapSeed >> 8) % 255) & rand1 % 255 & (rand1 >> 8) % 255
                                    & rand2 % 255;
    }
}