{
    unsigned char toDo = 0;
    {
        //Draw logo
        SetTileTable(logo);



        
        //"Press start" menu
        unsigned int blinkTimer = 0;
        unsigned char buttonPressed = 0;
        unsigned int firstBlinkTime = 0;
        while (true) {
            ClearVram();

            unsigned char logoX = 7;
            unsigned char logoY = 6;
            unsigned char tileVal = 14; 
            for (logoY = 3+3; logoY < 7+2+3; logoY++) {
                for (logoX = 7; logoX < 14+7; logoX++) {
                    SetTile(logoX, logoY, tileVal);
                    tileVal++;
                }
            }
            

            unsigned int joy = ReadJoypad(0);
            if (joy != 0 && buttonPressed == 0) {
                //button pressed
                buttonPressed = 1;
                firstBlinkTime = blinkTimer;
                blinkTimer = 0;
            } else if (joy == 0 && buttonPressed == 1) {
                //button released
                break;
            }
            if (blinkTimer < 50) {
                //Fill(7, 12, 13, 3, BLACK_TILE);
                //Print(8, 13, PSTR("Press%Start"));
                SetTile(10, 17, 1);
                SetTile(11, 17, 2);
                SetTile(12, 17, 3);
                SetTile(13, 17, 4);
                SetTile(14, 17, 5);
                SetTile(15, 17, 6);
                SetTile(16, 17, 7);
                                SetTile(10, 16, 10);
                SetTile(11, 16, 8);
                SetTile(12, 16, 8);
                SetTile(13, 16, 8);
                SetTile(14, 16, 8);
                SetTile(15, 16, 8);
                SetTile(16, 16, 9);
                //SetTile(15, 13, 8);
                
                
            } else if (blinkTimer >= 50+30) {
                blinkTimer = 0;
            }
            blinkTimer++;
            WaitVsync(1);
        }
        MENU_PING_HERE
        SetTileTable(image);
        ClearVram();
        
        unsigned int randomBits = firstBlinkTime;
        //Hopefully 6 bits of rand from when they pressed start.
        
        randomBits ^= (blinkTimer << 4);
        //Hopefully an extra bit (or two) from how long they took to release.
        //Also a bit of shuffling around just in case it helps.
        //6 bits now(ish) in "rightmost" spaces.
        
        unsigned char currentSelectionY = 10;
        blinkTimer = 0;
        unsigned char waitingForRelease = 0;
        
        unsigned int randomStore = 0;
        unsigned int releaseStore = 0;
        //unsigned char arrowStateTimer = 0;
        //menu loop
        while (true) {
            int joy = ReadJoypad(0);
            if (joy == 0 && waitingForRelease == 1) {
                //button released
                waitingForRelease = 0;
                releaseStore = blinkTimer;
                blinkTimer = 0;
            }
            
            //Draw main menu
            //ClearVram();
            Fill(6+1, 8, 14, 9, BLACK_TILE);
            Print(9+1, 10, PSTR("Load%game"));
            Print(9+1, 12, PSTR("New%game"));
            Print(9+1, 14, PSTR("Help"));
            
            /*unsigned char arrowToDraw = TILE_WITH_MENU_ARROW;
            if (arrowStateTimer < 10) {
                arrowToDraw = TILE_WITH_MENU_ARROW+0;
            } else if (arrowStateTimer < 20) {
                arrowToDraw = TILE_WITH_MENU_ARROW+1;
            } else if (arrowStateTimer < 30) {
                arrowToDraw = TILE_WITH_MENU_ARROW+2;
            } else if (arrowStateTimer <= 40) {
                arrowToDraw = TILE_WITH_MENU_ARROW+3;
            } else if (arrowStateTimer <= 50) {
                arrowToDraw = TILE_WITH_MENU_ARROW+4;
            } else if (arrowStateTimer <= 60) {
                arrowToDraw = TILE_WITH_MENU_ARROW+3;
            } else if (arrowStateTimer <= 70) {
                arrowToDraw = TILE_WITH_MENU_ARROW+2;
            } else if (arrowStateTimer <= 80) {
                arrowToDraw = TILE_WITH_MENU_ARROW+1;
            }
            if (arrowStateTimer == 80) {
                arrowStateTimer = 0;
            }
            SetTile(8+1, currentSelectionY, arrowToDraw);*/
            //arrowStateTimer++;
            //if (arrowStateTimer < 23) {
                SetTile(8+1, currentSelectionY, TILE_WITH_MENU_ARROW);
            //} else {
             /*   SetTile(8+1, currentSelectionY, BLACK_TILE);
            }
            if (arrowStateTimer == 35) {
                arrowStateTimer = 0;
            }*/
            
            if (joy & BTN_UP && waitingForRelease == 0) {
                if (currentSelectionY == 10) {
                    currentSelectionY = 14;
                } else {
                    currentSelectionY -= 2;
                }
                randomStore = blinkTimer;
                waitingForRelease = 1;
                blinkTimer = 0;
                MENU_PING_HERE
            }
            
            if (joy & BTN_DOWN && waitingForRelease == 0) {
                if (currentSelectionY == 14) {
                    currentSelectionY = 10;
                } else {
                    currentSelectionY += 2;
                }
                randomStore = blinkTimer;
                waitingForRelease = 1;
                blinkTimer = 0;
                MENU_PING_HERE
            }
            
            if (joy & BTN_A && waitingForRelease == 0) {
                MENU_YES_HERE
                if (currentSelectionY == 10) {
                    //toDo = 0;
                    //loadSave();
                    break;
                } else if (currentSelectionY == 12) {
                    //New game.
                    //randomStore and releaseStore should be set already.
                    //blinkTimer has more randomness.
                    //we have 6
                    randomBits ^= (randomStore << 6);
                    //now 10 bits are random (maybe?)
                    randomBits ^= (releaseStore << 10);
                    //I would guess 12 bits now?
                    randomBits ^= (blinkTimer << 12);
                    
                    /* Could time the release but meh.
                    blinkTimer = 0;
                    while (joy != 0) {
                        blinkTimer++;
                    }
                    //released and the final bits we need.
                    randomBits ^= (blinkTimer << 14);*/
                    
                    worldSeed = randomBits;
                    //Although. Lets be honest. We probably don't even need
                    //16 bits of randomness (or any at all).
                    //gen map.
                    toDo = 1;
                    break;
                } else if (currentSelectionY == 14) {
                    //Help
                    Fill(0, 0, 28, 28, BLACK_TILE);
                    
                    Print(3, 4, PSTR("You%mine%for%treasures"));
                    Print(3, 5, PSTR("using%^our%jetpack."));
                    
                    Print(3, 7, PSTR("You%can%sell%these%and"));
                    Print(3, 8, PSTR("refill%^our%energ^%at"));
                    Print(3, 9, PSTR("the%lightning%bolt"));
                    Print(3, 10, PSTR("building."));
                    
                    Print(3, 12, PSTR("Fl^%up%to%save."));
                    
                    Print(3, 14, PSTR("Bu^%upgrades%at"));
                    Print(3, 15, PSTR("the%shop."));
                    
                    Print(3, 17, PSTR("If%^ou%run%out%of"));
                    Print(3, 18, PSTR("energ^%^ou%lose."));
                    
                    Print(3, 22, PSTR("Good%luck."));
                    
                    while(ReadJoypad(0) != 0) {WaitVsync(1);}//wait for release
                    while(ReadJoypad(0) == 0) {WaitVsync(1);}//wait for press
                    MENU_YES_HERE
                    waitingForRelease = 1;
                    ClearVram();
                } 
            }
            
            blinkTimer++;
            WaitVsync(1);
        }
    }
    SetTileTable(image);
    //I'm kind of hoping to free up stack for these functions by
    //using this toDo variable.
    if (toDo == 1) {
        generateMap();
    } else {
        loadSave();
    }
}