
//unsigned char* line
//also passed in blocksDownIn
{
    if (blocksDownIn < 500+(28/2)-NUMBER_OF_LINES_JUST_ABOVE_GROUND) {
        unsigned char iii = 0;
        for (iii = 0; iii < 28/2; iii++) {
            line[iii] = 0;
        }
        return;
    } else if (blocksDownIn < 500+(28/2)) {
        unsigned char iii = 0;
        unsigned char lineNum = blocksDownIn-(500+(28/2))+NUMBER_OF_LINES_JUST_ABOVE_GROUND;
        for (iii = 0; iii < 28/2; iii++) {
            line[iii] = tilesJustAboveGround[lineNum][iii];
        }
        
        //lowest 2 lines can be mined.
        if (blocksDownIn >= 500+(28/2)-2) {
            for (iii = 0; iii < 28/2; iii++) {
                unsigned int bitWeNeed = iii+(blocksDownIn-(500+(28/2)-2))*(28/2);
                if ((tunneledArray[bitWeNeed/8] & (1 << bitWeNeed%8))) {
                    line[iii] = 0;
                }
            }
        }
        return;
    }
    
    //end game
    if (blocksDownIn > 500+300) {
        if (blocksDownIn > 500+300+40) {
            unsigned char iii = 0;
            for (iii = 0; iii < 28/2; iii++) {
                line[iii] = TILE_ROCK;
            }
            
            
            return;
        } else {
            unsigned char iii = 0;
            for (iii = 0; iii < 28/2; iii++) {
                line[iii] = 0;
            }
            
            //Draw other mole
            if (blocksDownIn == 500+300+40) {
                line[11] = TILE_PLAYER_BOTTOM_LEFT-6;
                //line[11] = TILE_PLAYER_BOTTOM_RIGHT-6;
            }
            if (blocksDownIn == 500+300+39) {
                //top of mole
                line[11] = TILE_PLAYER_BOTTOM_LEFT-6-4;
                //line[11] = TILE_PLAYER_TOP_RIGHT-3;
            }
            
            return;
        }
    }
    
    //Normal:
    
    unsigned int seed = worldSeed ^ blocksDownIn;
    unsigned int blocksDown = blocksDownIn-500;
    unsigned char iii = 0;
    for (iii = 0; iii < (28/2); iii++) {
        //Always update seed.
        seed ^= (seed << 13);
        seed ^= (seed >> 9);
        seed ^= (seed << 7);
        
        //If already mined fill blank.
        unsigned int bitWeNeed = iii+blocksDown*(28/2)-(24*8)-(28/2)*2-4+((28/2)*4);
        //PrintInt(5, 5, bitWeNeed/8, 1);
        //PrintInt(9, 6, bitWeNeed/8 ,1);
        if (!(tunneledArray[bitWeNeed/8] & (1 << bitWeNeed%8))) {
            unsigned char blockID = TILE_BLOCK;

            unsigned char type = seed & 0x0F;
            unsigned int newSeed = seed >> 4;
            
            //It turns out we can't shift more than 16 in one go.
            unsigned char shiftAmount = blocksDown/32+lookupShiftForType[type];
            if (shiftAmount > 12) {
                shiftAmount = 12;
            }

            //Shift 11 will give 50%. shift 0 gives very low chance.
            newSeed = newSeed >> shiftAmount;
            
            //Hopefully this line below will be optimized better by the compiler
            if (blocksDown & (1 << 4)) {
                //if we're half way through super block then make it more common.
                newSeed = newSeed - newSeed/4;
            }

            if (newSeed == 0) {
                //We have shifted all the digits out. It's a block.
                blockID = lookupForTileNum[type];
            }
            
            line[iii] = blockID;
        } else {
            //mined
            line[iii] = 0;
        }
    }
    
}
